=== test/stress/freelist/CMakeLists.txt ===
set(PACKAGE_NAME stress-freelist)

set(CDSSTRESS_FREELIST_SOURCES
    ../main.cpp
    put_get.cpp
    put_get_single.cpp
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable(${PACKAGE_NAME} ${CDSSTRESS_FREELIST_SOURCES})
target_link_libraries(${PACKAGE_NAME} ${CDS_TEST_LIBRARIES} ${CDSSTRESS_FRAMEWORK_LIBRARY})

add_test(NAME ${PACKAGE_NAME} COMMAND ${PACKAGE_NAME} WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
