=== test/unit/deque/CMakeLists.txt ===
set(PACKAGE_NAME unit-deque)

set(CDSGTEST_DEQUE_SOURCES
    ../main.cpp
    fcdeque.cpp
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable(${PACKAGE_NAME} ${CDSGTEST_DEQUE_SOURCES})
target_link_libraries(${PACKAGE_NAME} ${CDS_TEST_LIBRARIES})

add_test(NAME ${PACKAGE_NAME} COMMAND ${PACKAGE_NAME} WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
