=== debian/changelog ===
libcds (2.3.3-6) unstable; urgency=medium

  * debian/control: bump standard to 4.7.2 (no changes)
  * add debian/patch/cmake4.patch (Closes: #1113126)

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 04 Sep 2025 19:02:22 +0200

libcds (2.3.3-5) unstable; urgency=medium

  * debian/control: bump standard to 4.7.0 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 08 Sep 2024 22:02:22 +0200

libcds (2.3.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062247

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 10:19:17 +0000

libcds (2.3.3-4) unstable; urgency=medium

  * upload to unstable
  * debian/control: bump standard to 4.6.2 (no changes)
  * introduce more know arches (Closes: #1025376)
    Thanks to Bo YU for the patch!

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 29 Oct 2023 10:02:22 +0100

libcds (2.3.3-3) experimental; urgency=medium

  * debian/control: use dh13
  * debian/control: bump standard to 4.5.1 (no changes)
  * avoid FTBFS on some 64-bit archs (Closes: #987760)
    Thanks to Yangfl for the patch!

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 16 Jul 2021 16:02:22 +0200

libcds (2.3.3-2) unstable; urgency=medium

  * source upload
  * debian/*.install: user better path for installation (Closes: #934471)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 11 Aug 2019 19:23:22 +0200

libcds (2.3.3-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 22 Jul 2019 19:53:22 +0200
